package operaciones;

import java.math.BigDecimal;
import java.util.Iterator;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import  conexion.*;
import  datos.*;

import org.hibernate.JDBCException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;

public class OperacionesProveedores {

	SessionFactory sesion = conexionBD.getSessionFactory();		
	Session session = sesion.openSession();		
	Erroressql vererror=new Erroressql();
	
////////////////////////////////////////////////
public void cargadatosprovecomboprove(JComboBox comboProveedor, JTextField nombreprov) {
		Proveedores prov = new Proveedores();	
		prov = (Proveedores) session.get(Proveedores.class, comboProveedor.getSelectedItem().toString()); 	
		nombreprov.setText(prov.getNombre() + ", " + prov.getApellidos());
	}
//////////////////////////////////////////////////////////////////////	
public void listarproveedores( JTextArea ta) {

		ta.setText("");
		Query consulta = session.createQuery("from Proveedores");

		ta.append("............................ DATOS DE PROVEEDORES ..........................................\n");
		ta.append(String.format("%1$-8s", "CODIGO")
				+ String.format("%1$-25s", "NOMBRE")
				+ String.format("%1$-25s", "APELLIDOS")
				+ String.format("%1$-45s", "DIRECCIÓN")
				+ String.format("%1$-11s", "COMISIÓN" )
				);

		ta.append("\n------------------------------------------------------------------------------"
    			+ "-----------------------------------\n");
		Iterator q = consulta.iterate();
		Proveedores prov = new Proveedores();
    	while (q.hasNext()) {
			prov =  (Proveedores) q.next();

			ta.append(String.format("%1$-8s", prov.getCodigo())
					+ String.format("%1$-25s", prov.getNombre())
					+ String.format("%1$-25s", prov.getApellidos()) 
					+ String.format("%1$-45s", prov.getDireccion()) 
					+ String.format("%1$-11s", prov.getComision()) 
					+ "\n");
		
		}
    	ta.append("------------------------------------------------------------------------------"
    			+ "-----------------------------------\n");
 
} // fin listar piezas

////////////////////////////////////////////////////////////
public void insertarproveedor(JTextField codprov, JTextField nombreprov,
			JTextField apellidoprov, JTextField direccionprov,
			JTextField comision, JLabel mensaje) {
	
	Proveedores provv=new Proveedores();
	// comprobar si existe
	provv = (Proveedores) session.get(Proveedores.class, codprov.getText().toString() );	
	if (provv==null) {
	// Proveedor nuevo
	provv=new Proveedores();
	String codigo=codprov.getText().toString() ;
	String nombre=nombreprov.getText().toString() ;
	String ape=apellidoprov.getText().toString() ;
	String dire=direccionprov.getText().toString() ;
	// Validamos las cadenas, que no sobrepasen a longitud
	if (codigo.length() > 6 ) codigo = (codprov.getText().toString()).substring(0,6);
	if (nombre.length()>20) nombre = (nombreprov.getText().toString()).substring(0,20);
    if (ape.length()>30) ape =(apellidoprov.getText().toString()).substring(0,30);
    if (dire.length()>40)	dire = (direccionprov.getText().toString()).substring(0,40);
        
    try {
	    float comi = Float.parseFloat(comision.getText().toString() );
		BigDecimal comis =BigDecimal.valueOf(comi);
		
	    provv.setCodigo(codigo);
		provv.setApellidos(ape);
		provv.setNombre(nombre);
		provv.setDireccion(dire);
		provv.setComision(comis);
		
		Transaction tx =session.beginTransaction();
		session.save(provv);
		tx.commit();
		mensaje.setText("PROVEEDOR : " + codigo + " INSERTADO ");
    
    }catch (NumberFormatException e) {
    	mensaje.setText("ERROR EN LA COMISION. Debe ser numérico." ); 
	
	}catch (JDBCException j)
 	{   vererror.erroresMySQL(j,mensaje); 	
 	    session.close();
        session = sesion.openSession();	}	 
	}
	else
	{ // proveedor ya existe
	 mensaje.setText("PROVEEDOR : " + codprov.getText().toString() + " YA EXISTE ");	
	 cargaproveepantalla(codprov, nombreprov, apellidoprov, direccionprov,
				comision, provv);
	}
} //insertarproveedor
/////////////////////////////////////////////////////////////////////////
public Proveedores buscarprov(JTextField codprov)
{
	Proveedores prove=new Proveedores();
	prove = (Proveedores) session.get(Proveedores.class, codprov.getText().toString() );		
    return prove;
}
////////////////////////////////////////////////////////
public void anterior(JTextField codprov, JTextField nombreprov,
		JTextField apellidoprov, JTextField direccionprov,
		JTextField comision, JLabel mensaje) {
	Query consulta = session.createQuery("from Proveedores order by codigo desc");
	mensaje.setText("--------------------------------------------------------");
	List <Proveedores> lista = consulta.list();

	if (lista.size()>0)
	{
	   Iterator q = lista.iterator();
     	boolean salir = true;
    	Proveedores provv = new Proveedores();
    	System.out.println(" --------------- " );

	while (q.hasNext() && salir) {
		provv =  (Proveedores) q.next();
		System.out.println(" pieza: " + provv.getCodigo());
		if  (codprov.getText().length()==0 || buscarprov(codprov) == null ) 
		{    // carga el primero
			cargaproveepantalla(codprov, nombreprov, apellidoprov,
					direccionprov, comision, provv);
			salir=false;
		}
		else{
			if (provv.getCodigo().equalsIgnoreCase(codprov.getText().toString() ))
			{ 
				if (q.hasNext()) 
				{
				provv =  (Proveedores) q.next();
				cargaproveepantalla(codprov, nombreprov, apellidoprov,
						direccionprov, comision, provv);
				salir=false;
				}
			}
		}
	
	}
	} // if lista.size	
}// anterior

private void cargaproveepantalla(JTextField codprov, JTextField nombreprov,
		JTextField apellidoprov, JTextField direccionprov, JTextField comision,
		Proveedores provv) {
	codprov.setText(provv.getCodigo());
	nombreprov.setText(provv.getNombre()) ;
	apellidoprov.setText(provv.getApellidos());
	direccionprov.setText(provv.getDireccion());
	comision.setText(provv.getComision().toString());
}
////////////////////////////////////////////////////////////
public void siguiente(JTextField codprov, JTextField nombreprov,
		JTextField apellidoprov, JTextField direccionprov,
		JTextField comision, JLabel mensaje) 
{	
Query consulta = session.createQuery("from Proveedores order by codigo");
Iterator q = consulta.iterate();
boolean salir = true;
Proveedores provv = new Proveedores();
mensaje.setText("--------------------------------------------------------");
while (q.hasNext() && salir) {
    provv =  (Proveedores) q.next();
	if  (codprov.getText().length()==0 || buscarprov(codprov) == null ) 
	{
		cargaproveepantalla(codprov, nombreprov, apellidoprov, direccionprov,
				comision, provv);
		salir=false;
    }
else{
	if (provv.getCodigo().equalsIgnoreCase(codprov.getText().toString() ))
	{ 
		if (q.hasNext()) 
		{
		provv =  (Proveedores) q.next();
		cargaproveepantalla(codprov, nombreprov, apellidoprov, direccionprov,
				comision, provv);
		salir=false;
		}
		
	}
	} // fin else	
}	
}// siguiente
////////////////////////////////////////////////////////////
public Proveedores consultar(JTextField codprov, JTextField nombreprov,
	JTextField apellidoprov, JTextField direccionprov,
	JTextField comision, JLabel mensaje) {

Proveedores provv=new Proveedores();

provv = (Proveedores) session.get(Proveedores.class, codprov.getText().toString());	
if (provv==null) {			
 System.out.println("PROVEEDOR no existe: " + codprov.getText().toString() );
 mensaje.setText("PROVEEDOR : " + codprov.getText().toString() + " NO EXISTE ");
 nombreprov.setText(" ");
 apellidoprov.setText(" "); 
 direccionprov.setText(" ");
 comision.setText(" ");
}
else
{
 System.out.println("PROVEEDOR SI existe: " + codprov.getText().toString() );
 mensaje.setText("PROVEEDOR : " + codprov.getText().toString() + " SII EXISTE ");	
 cargaproveepantalla(codprov, nombreprov, apellidoprov, direccionprov,
			comision, provv);
}

return provv;

}

///////////////////////////////////////////////////////////
public void borrarprov(JTextField codprov, JTextField nombreprov,
		JTextField apellidoprov, JTextField direccionprov, JTextField comision,
		JLabel mensaje, JPanel jp) {

Proveedores provv=new Proveedores();
provv = (Proveedores) session.get(Proveedores.class, codprov.getText().toString());	
if (provv==null) {			
 System.out.println("PROVEEDOR no existe: " + codprov.getText().toString() );
 mensaje.setText("PROVEEDOR : " + codprov.getText().toString() + " NO EXISTE, NO SE BORRA. ");
}
else
{
 System.out.println("PROVEEDOR SI existe: " + codprov.getText().toString() );
 int confirm=JOptionPane.showConfirmDialog
         (jp, "ESTAS SEGURO DE BORRAR ESTE PROVEEDOR: " + codprov.getText().toString()  ,
        		 "AVISO BORRADO.", 
	    	JOptionPane.OK_CANCEL_OPTION);	  
 if (confirm==0)  
   {  
	 try {
		 Transaction tx =session.beginTransaction();
		 session.delete(provv);
		 tx.commit();
		 mensaje.setText("PROVEEDOR : " + codprov.getText().toString() + " SII EXISTE, BORRADO.");
		 nombreprov.setText(" ");
		 apellidoprov.setText(" ");  direccionprov.setText(" ");
		 comision.setText(" ");
		}catch (JDBCException j)
		{   vererror.erroresMySQL(j,mensaje); 	
		    session.close();
	        session = sesion.openSession();	}	
   }// fin confirm
}
	
} // fin borrarprov

/////////////////////////////////////////////////////////
public void modificarprov(JTextField codprov, JTextField nombreprov,
		JTextField apellidoprov, JTextField direccionprov, JTextField comision,
		JLabel mensaje) {
Proveedores provv=new Proveedores();
// comprobar si existe
provv = (Proveedores) session.get(Proveedores.class, codprov.getText().toString());	
if (provv!=null) {
// Proveedor ya existe
	String codigo=codprov.getText().toString();
	String nombre=nombreprov.getText().toString();
	String ape=apellidoprov.getText().toString();
	String dire=direccionprov.getText().toString();
	// Validamos las cadenas, que no sobrepasen a longitud
	if (nombre.length()>20) nombre = (nombreprov.getText().toString()).substring(0,20);
	if (ape.length()>30) ape =(apellidoprov.getText().toString()).substring(0,30);
	if (dire.length()>40)	dire = (direccionprov.getText().toString()).substring(0,40);

    try {
	    float comi = Float.parseFloat(comision.getText().toString());
		BigDecimal comis =BigDecimal.valueOf(comi);
	    provv.setCodigo(codigo);
		provv.setApellidos(ape);
		provv.setNombre(nombre);
		provv.setDireccion(dire);
		provv.setComision(comis);
		Transaction tx =session.beginTransaction();
		session.save(provv);
		tx.commit();
		mensaje.setText("PROVEEDOR : " + codigo + " MODIFICADO ");
	}catch (NumberFormatException e) {
		mensaje.setText("ERROR EN LA COMISION. Debe ser numérico." );
	}catch (JDBCException j)
	{   vererror.erroresMySQL(j,mensaje); 	
	    session.close();
	    session = sesion.openSession();	}		
	}
else
 mensaje.setText("PROVEEDOR : " + codprov.getText().toString() + " NO EXISTE, no se puede actualizar ");			
} // fin modificarprov

///////////////////////////////////////////////////////////////////////7
public void cargarcombo(JComboBox comboProveedor, JTextField nombreprov) {
	Query consulta = session.createQuery("from Proveedores");	
	List <Proveedores> q = consulta.list();
	Proveedores prov = new Proveedores();
    for (int i=0;i<q.size();i++)
	 {  
		prov =  (Proveedores) q.get(i);
		comboProveedor.addItem(prov.getCodigo());
		if (i==0) nombreprov.setText(prov.getNombre());
	}
    comboProveedor.setSelectedIndex(0);
    
}
/////////////////////////////////////////////////////////////////////////
public Proveedores cargaprove( String codigo) {
	Proveedores prov = new Proveedores();	
	prov = (Proveedores) session.get(Proveedores.class, codigo); 
	return prov;

}
} // fin clase
