package operaciones;

import java.math.BigDecimal;
import java.util.Iterator;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import  conexion.*;
import  datos.*;

import org.hibernate.JDBCException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;

public class OperacionesProyectos {
	SessionFactory sesion = conexionBD.getSessionFactory();		
	Session session = sesion.openSession();		
    Erroressql vererror=new Erroressql();

///////////////////////////////////////////////
public Proyectos buscarproyecto(JTextField codproyec)
{	
	Proyectos proy=new Proyectos();
	proy = (Proyectos) session.get(Proyectos.class, codproyec.getText().toString());
	return proy;
}//buscarproyecto
///////////////////////////////////////////////////////////////////
public void cargadatosproyectocombo( JComboBox comboProyecto, JTextField nombreproyec) {	
Proyectos proy = new Proyectos();
proy = (Proyectos) session.get(Proyectos.class, comboProyecto.getSelectedItem().toString()); 
nombreproyec.setText(proy.getNombre());	
}
///////////////////////////////////////////////////////////
public void cargarzonas( JComboBox lzo) {
	Query consulta = session.createQuery("from Zonas");	
	Iterator q = consulta.iterate();
	Zonas pi = new Zonas();
	while (q.hasNext()) {
		pi =  (Zonas) q.next();
        lzo.addItem(pi.getCodigo() + "/" + pi.getNombre());
        System.out.println(" ZON: " + pi.getCodigo());
	}
} // fin cargarzonas
///////////////////////////////////////////////////////////
public void listarproyectos( JTextArea ta) {

		ta.setText("");
		Query consulta = session.createQuery("from Proyectos order by codigo");

		ta.append("................................. DATOS DE PROYECTOS .................................\n");
		ta.append(String.format("%1$-8s", "CODIGO")
				+ String.format("%1$-25s", "NOMBRE")
				+ String.format("%1$-25s", "CIUDAD")
				+ String.format("%1$-15s", "PRESUPUESTO")
				+ String.format("%1$-15s", "ZONA" )
				);
	   	ta.append("\n-------------------------------------------------------------------------------------\n");

		List <Proyectos> q = consulta.list();
		Proyectos pi = new Proyectos();
    	for (int i=0;i<q.size();i++){
			pi =  (Proyectos) q.get(i);
			ta.append(String.format("%1$-8s", pi.getCodigo())
					+ String.format("%1$-25s", pi.getNombre())
					+ String.format("%1$-25s", pi.getCiudad()) 
					+ String.format("%1$-15s", pi.getPresupuesto()) 
					+ String.format("%1$-15s", pi.getZonas().getNombre()) 
					+ "\n");
		}
       	ta.append("\n-------------------------------------------------------------------------------------\n");
    	
	} // fin listar proyectos
////////////////////////////////////////////////////////////
public void anterior(JTextField codproy, JTextField nombrepry,
		JTextField ciudad, JTextField presupuesto,
		JComboBox comboZona, JLabel mensaje) 
{
	Query consulta = session.createQuery("from Proyectos order by codigo desc");
	mensaje.setText("--------------------------------------------------------");
	List <Proyectos> lista = consulta.list();
	if (lista.size()>0)
	{
	    Iterator q = lista.iterator();
     	boolean salir = true;
     	Proyectos proy = new Proyectos();
	    while (q.hasNext() && salir) {
		  proy =  (Proyectos) q.next();
		  System.out.println(" Proyecto: " + proy.getCodigo());
	 	  if  (codproy.getText().length()==0 || buscarproyecto(codproy) == null ) 
		  {  
			visualizaproyectopantalla(codproy, nombrepry, ciudad, presupuesto,
					comboZona, proy);
			salir=false;
		   }
		   else{
			if (proy.getCodigo().equalsIgnoreCase(codproy.getText().toString()))
			{ 
				if (q.hasNext()) 
				{
				proy =  (Proyectos) q.next();
				visualizaproyectopantalla(codproy, nombrepry, ciudad,
						presupuesto, comboZona, proy);
				salir=false;
				}
			}
		}
	
	}// fin while
	} // if lista.size	
}// anterior
////////////////////////////////////////////////////////////
private void visualizaproyectopantalla(JTextField codproy,
		JTextField nombrepry, JTextField ciudad, JTextField presupuesto,
		JComboBox comboZona, Proyectos proy) {
	codproy.setText(proy.getCodigo());
	nombrepry.setText(proy.getNombre()) ;
	ciudad.setText(proy.getCiudad());
	presupuesto.setText(proy.getPresupuesto().toString());
	int zona =  proy.getZonas().getCodigo();
	visualizarzonaencombo(comboZona, zona);
}
////////////////////////////////////////////////////////////
public void siguiente (JTextField codproy, JTextField nombrepry,
		JTextField ciudad, JTextField presupuesto,
		JComboBox comboZona, JLabel mensaje)  {

	Query consulta = session.createQuery("from Proyectos order by codigo");

	Iterator q = consulta.iterate();
	boolean salir = true;
	Proyectos proy = new Proyectos();
	mensaje.setText("--------------------------------------------------------");
	while (q.hasNext() && salir) {
	    proy =  (Proyectos) q.next();
		if  (codproy.getText().length()==0 || buscarproyecto(codproy) == null ) 
		{
			visualizaproyectopantalla(codproy, nombrepry, ciudad, presupuesto,
					comboZona, proy);
			salir=false;
	    }
	else{
		if (proy.getCodigo().equalsIgnoreCase(codproy.getText().toString()))
		{ 
			if (q.hasNext()) 
			{
				proy =  (Proyectos) q.next();
				visualizaproyectopantalla(codproy, nombrepry, ciudad,
						presupuesto, comboZona, proy);
				salir=false;
			}
			
		}
		} // fin else	
	}	
}// siguiente
///////////////////////////////////////////////////////////
public void insertarproyecto(JTextField codproy, JTextField nombreproy,
		JTextField ciudadproy, JTextField presupuestoproy, JComboBox comboZona,
		JLabel mensaje) 
{
	Proyectos proyec = (Proyectos) session.get(Proyectos.class, codproy.getText().toString());	
	if (proyec!=null) {			
	 mensaje.setText("PROYECTO : " + codproy.getText().toString() + " YA EXISTE, NO SE INSERTA. ");
	}
	else
	{
	 proyec = new Proyectos();
	 try {
		 if (codproy.getText().toString().trim().length()>0)
		    {
			    comunmodificarinsertar(codproy, nombreproy, ciudadproy,
						presupuestoproy, comboZona, proyec);
				Transaction tx =session.beginTransaction();
				session.save(proyec);
				tx.commit();
				mensaje.setText("PROYECTO : " + codproy.getText().toString() + " INSERTADO ");
		    }
		 else
			    mensaje.setText("CÓDIGO DE PROYECTO NO PUEDE ESTAR VACÍO. "); 
		}catch (NumberFormatException e) {
			mensaje.setText("ERROR EN EL PRESUPUESTO. Debe ser numérico entero." );
		}catch (JDBCException j)
		{   vererror.erroresMySQL(j,mensaje); 	
		    session.close();
	        session = sesion.openSession();	}		
	}
	
}//insertarproyecto
///////////////////////////////////////////////////////////

public void borrarproyecto(JTextField codproy, JTextField nombreproy,
		JTextField ciudadproy, JTextField presupuestoproy, JComboBox comboZona,
		JLabel mensaje, JPanel jp) 
{
	Proyectos provv=new Proyectos();
	provv = (Proyectos) session.get(Proyectos.class, codproy.getText().toString());	
	if (provv==null) {			
	 System.out.println("PROYECTO no existe: " + codproy.getText().toString() );
	 mensaje.setText("PROYECTO : " + codproy.getText().toString() + " NO EXISTE, NO SE BORRA. ");

	}
	else
	{
	 int confirm=JOptionPane.showConfirmDialog
	         (jp, "ESTAS SEGURO DE BORRAR ESTE PROYECTO: " + codproy.getText().toString()  ,
	        		 "AVISO BORRADO.", 
		    	JOptionPane.OK_CANCEL_OPTION);	  
	 if (confirm==0)  
	   {  
		 try {
			 Transaction tx =session.beginTransaction();
			 session.delete(provv);
			 tx.commit();
			 mensaje.setText("PROYECTO : " + codproy.getText().toString() + " SII EXISTE, BORRADO.");
			 nombreproy.setText("");
			 ciudadproy.setText("");  
			 presupuestoproy.setText("");
			 comboZona.setSelectedIndex(0);
			 codproy.setText("");
			}catch (JDBCException j)
			{   vererror.erroresMySQL(j,mensaje); 	
			    session.close();
		        session = sesion.openSession();	}
	   }// fin confirm
	}
	
}//borrarproyecto
///////////////////////////////////////////////////////////

public void modificarproyecto(JTextField codproy, JTextField nombreproy,
		JTextField ciudadproy, JTextField presupuestoproy, JComboBox comboZona,
		JLabel mensaje) {
	
	Proyectos proyec = (Proyectos) session.get(Proyectos.class, codproy.getText().toString());	
	if (proyec==null) {			
	 mensaje.setText("PROYECTO : " + codproy.getText().toString() + " NO EXISTE, NO SE MODIFICA. ");
	}
	else
	{
	 System.out.println("PROYECTO SI existe: " + codproy.getText().toString() );
	 try { 
		 if (codproy.getText().toString().trim().length()>0)
		    { comunmodificarinsertar(codproy, nombreproy, ciudadproy,
						presupuestoproy, comboZona, proyec);
				Transaction tx =session.beginTransaction();
				session.update(proyec);
				tx.commit();
				mensaje.setText("PROYECTO : " + codproy.getText().toString() + " MODIFICADO. ");
			}
	      else
		       mensaje.setText("CÓDIGO DE PROYECTO NO PUEDE ESTAR VACÍO. "); 
		}catch (NumberFormatException e) {
			mensaje.setText("ERROR EN EL PRESUPUESTO. Debe ser numérico entero." );
		}catch (JDBCException j)
		{   vererror.erroresMySQL(j,mensaje); 	
		    session.close();
	        session = sesion.openSession();	}		
	}

}//modificarproyecto
///////////////////////////////////////////////////////////

private void comunmodificarinsertar(JTextField codproy, JTextField nombreproy,
		JTextField ciudadproy, JTextField presupuestoproy, JComboBox comboZona,
		Proyectos proyec) {
	int presup = Integer.parseInt(presupuestoproy.getText().toString().trim());
	proyec.setPresupuesto(presup);
	proyec.setCodigo(codproy.getText().toString().trim());
	proyec.setNombre(nombreproy.getText().toString().trim());
	proyec.setCiudad(ciudadproy.getText().toString().trim());
	// extraer la zona del combo
	String zonacombo=comboZona.getSelectedItem().toString();
	int zonacom = Integer.parseInt(zonacombo.substring(0,zonacombo.indexOf("/")).trim());
	//buscar el objeto zona a insertar en la tabla
	Zonas zz = (Zonas) session.get(Zonas.class, zonacom);
	proyec.setZonas(zz);
}

public void consultarproyecto(JTextField codproy, JTextField nombreproy,
		JTextField ciudadproy, JTextField presupuestoproy, JComboBox comboZona,
		JLabel mensaje) {

	Proyectos proyec=new Proyectos();

	proyec = (Proyectos) session.get(Proyectos.class, codproy.getText().toString());	
	if (proyec==null) {			
	 mensaje.setText("PROYECTO: " + codproy.getText().toString() + " NO EXISTE ");
	 nombreproy.setText(" ");
	 ciudadproy.setText(" ");  presupuestoproy.setText(" ");
	 comboZona.setSelectedIndex(0);
	}
	else
	{
	 mensaje.setText("PROYECTO : " + codproy.getText().toString() + " SII EXISTE ");
	 nombreproy.setText(proyec.getNombre());
	 ciudadproy.setText(proyec.getCiudad());  
	 presupuestoproy.setText(proyec.getPresupuesto().toString());
	 int zona =  proyec.getZonas().getCodigo();
	 visualizarzonaencombo(comboZona, zona);
	}

}//consultarproyecto

private void visualizarzonaencombo(JComboBox comboZona, int zona) {
	for (int i=0;i<comboZona.getItemCount();i++)
	 {  // extraer el código de zona del combo
		comboZona.setSelectedIndex(i);
		String zonacombo=comboZona.getSelectedItem().toString();
	    int zonacom = Integer.parseInt(zonacombo.substring(0,zonacombo.indexOf("/")).trim());
	    if (zona == zonacom )
		  {  break;}
	 }
}//visualizarzonaencombo
///////////////////////////////////////////////////////////////////////7
public void cargarcombo(JComboBox comboProyec, JTextField nombreproyec) {
	Query consulta = session.createQuery("from Proyectos");	
	List <Proyectos> q = consulta.list();
	Proyectos prov = new Proyectos();
	for (int i=0;i<q.size();i++)
	{  
	prov =  (Proyectos) q.get(i);
	comboProyec.addItem(prov.getCodigo());
	if (i==0) nombreproyec.setText(prov.getNombre());
	}
	comboProyec.setSelectedIndex(0);
	
	}
/////////////////////////////////////////////////////////////////////////

public Proyectos cargaproyec( String codigo) {
	Proyectos prov = new Proyectos();	
	prov = (Proyectos) session.get(Proyectos.class, codigo); 
	return prov;

}
} // fin clase
