package operaciones;

import java.awt.TextArea;
import java.math.BigDecimal;
import java.util.Iterator;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import  conexion.*;
import  datos.*;

import org.hibernate.JDBCException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;

public class OperacionesSuministros {
	SessionFactory sesion = conexionBD.getSessionFactory();		
	Session session = sesion.openSession();		
	Erroressql vererror=new Erroressql();
////////////////////////////////////////////////////////////////////		
public void cargarcombos( JComboBox lpi, JComboBox lprov, JComboBox lproyec) {	
		Query consulta = session.createQuery("from Piezas");	
		Iterator q = consulta.iterate();
		Piezas pi = new Piezas();
    	while (q.hasNext()) {
			pi =  (Piezas) q.next();
            lpi.addItem(pi.getCodigo());
            System.out.println(" Piez: " + pi.getCodigo());
		}
    	consulta = session.createQuery("from Proveedores");	
		 q = consulta.iterate();
		Proveedores prov = new Proveedores();
	
    	while (q.hasNext()) {
    		prov =  (Proveedores) q.next();
            lprov.addItem(prov.getCodigo());
            System.out.println(" Prov: " + prov.getCodigo());
		}
    	consulta = session.createQuery("from Proyectos");	
		 q = consulta.iterate();
		Proyectos proye = new Proyectos();
	
      	while (q.hasNext()) {
   		proye =  (Proyectos) q.next();
           lproyec.addItem(proye.getCodigo());
           System.out.println(" Proyec: " + proye.getCodigo());
		}

	}
/////////////////////////////////////////////////////////////////////////////
public void cargadatosprovecomboprove(JComboBox comboProveedor, JTextField nombreprov) {
	Proveedores prov = new Proveedores();	
	prov = (Proveedores) session.get(Proveedores.class, comboProveedor.getSelectedItem().toString()); 	
	nombreprov.setText(prov.getNombre() + ", " + prov.getApellidos());
}
///////////////////////////////////////////////////////////////////
public void cargadatosproyectocombo( JComboBox comboProyecto, JTextField nombreproyec) {	
		Proyectos proy = new Proyectos();
		proy = (Proyectos) session.get(Proyectos.class, comboProyecto.getSelectedItem().toString()); 
		nombreproyec.setText(proy.getNombre());	
	}
	/////////////////////////////////////////////////////////////////
public void cargadatopiezacombo( JComboBox comboPiezas, JTextField nombrepieza, JTextField pvppieza) {
		Piezas pie = new Piezas();	
		pie = (Piezas) session.get(Piezas.class, comboPiezas.getSelectedItem().toString()); 
		nombrepieza.setText(pie.getNombre());
		pvppieza.setText(pie.getPrecio().toString());
	}
///////////////////////////////////////////////////////////////////////
public void listarpiezas( TextArea textArea) {
		
		textArea.setText("");
		Query consulta = session.createQuery("from Piezas");
		textArea.append("\n--------------------------------- DATOS DE PIEZAS ---------------------"
				+ "---------------------------------------------\n\n");

		textArea.append(String.format("%1$-8s", "CODIGO")
				+ String.format("%1$-25s", "NOMBRE")
				+ String.format("%1$-10s", "PRECIO")
				+ String.format("%1$-10s", "STOCK")
				+ String.format("%1$-13s", "A REPONER")
				+ String.format("%1$-11s", "DESCRIPCION")
				);

		textArea.append("\n-----------------------------------------------------------------------"
				+ "---------------------------------------------\n");

		Iterator q = consulta.iterate();
		Piezas pi = new Piezas();
		String areponer;
    	while (q.hasNext()) {
			pi =  (Piezas) q.next();
            if (pi.getStock() <= 2 ) areponer="A REPONER";
            else areponer=" ";
			textArea.append(String.format("%1$-8s", pi.getCodigo())
					+ String.format("%1$-25s", pi.getNombre())
					+ String.format("%1$-10s", pi.getPrecio()) 
					+ String.format("%1$-10s", pi.getStock()) 
					+ String.format("%1$-13s", areponer) 
					+ String.format("%1$-30s", pi.getDescripcion()) 
					+ "\n");
		
		}
    	textArea.append("-----------------------------------------------------------------------"
				+ "---------------------------------------------\n");

	} // fin listar piezas
///////////////////////////////////////////////////////////////////////
public void consultarreg(JComboBox comboPiezas, JComboBox comboProveedor,
			JComboBox comboProyecto, JTextField cantidad, JTextField importe, JLabel mensaje) {

	GestionId id = new GestionId(comboProveedor.getSelectedItem().toString(),
			comboPiezas.getSelectedItem().toString(),
			comboProyecto.getSelectedItem().toString() );

	Gestion gest = (Gestion) session.get(Gestion.class, id); 
	if (gest==null){
		// Suministro no existe 
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +",  NO EXISTE EN LA BD. ");
	}
	else
	{
		cantidad.setText(gest.getCantidad().toString());
		float impor = gest.getCantidad() * gest.getPiezas().getPrecio().floatValue();
		importe.setText(String.valueOf(impor));
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +", YA SE ENCUENTRA EN LA BD. ");
	}
}//consultarreg

///////////////////////////////////////////////////////////////////////
public void insertarsuministro(JComboBox comboPiezas, JComboBox comboProveedor,
		JComboBox comboProyecto, JTextField cantidad,  JTextField importe, JLabel mensaje) {
	GestionId id = new GestionId(comboProveedor.getSelectedItem().toString(),
			comboPiezas.getSelectedItem().toString(),
			comboProyecto.getSelectedItem().toString() );

	Gestion gest = (Gestion) session.get(Gestion.class, id); 
	if (gest!=null){
		// Suministro YA existe 
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +",  YA EXISTE EN LA BD. ");
	}
	else
	{
	try{
		Proyectos pr = (Proyectos)session.get(Proyectos.class, comboProyecto.getSelectedItem().toString()); 
		Proveedores prov = (Proveedores)session.get(Proveedores.class, comboProveedor.getSelectedItem().toString()); 
		Piezas pie = (Piezas)session.get(Piezas.class, comboPiezas.getSelectedItem().toString()); 
		int canti = Integer.parseInt(cantidad.getText().toString());	
		float impor = canti * pie.getPrecio().floatValue();
		importe.setText(String.valueOf(impor));
		Gestion gesti = new Gestion();
		gesti.setCantidad(canti);
		gesti.setId(id);
		gesti.setPiezas(pie);
		gesti.setProveedores(prov);
		gesti.setProyectos(pr);
		// actualiza pieza, resto unidades
		int st = pie.getStock();
		st = st - canti;
		if (st >=10)
		{ 	pie.setStock(st);
			Transaction tx =session.beginTransaction();
			session.save(gesti);
			session.update(pie);
			tx.commit();
			mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +", INSERTADO EN LA BD. ");
		}
		else{
			mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
					comboPiezas.getSelectedItem().toString()+ "-" +
					comboProyecto.getSelectedItem().toString()    +", NO INSERTADO EN LA BD. "
							+ " El stock es menor de 10.");
		}
	}catch (NumberFormatException e) {
		mensaje.setText("ERROR EN LA CANTIDAD. Debe ser numérico entero." );
	}catch (JDBCException j)
	{   vererror.erroresMySQL(j,mensaje); 	
	    session.close();
	    session = sesion.openSession();	}		
	}
	
}//insertarsuministro

///////////////////////////////////////////////////////////////////////
public void borrarsuministro(JComboBox comboPiezas, JComboBox comboProveedor,
		JComboBox comboProyecto, JTextField cantidad, JTextField Importe, JLabel mensaje, JPanel jp) 
{
	GestionId id = new GestionId(comboProveedor.getSelectedItem().toString(),
			comboPiezas.getSelectedItem().toString(),
			comboProyecto.getSelectedItem().toString() );

	Gestion gest = (Gestion) session.get(Gestion.class, id); 
	if (gest==null){
		// Suministro NO existe 
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +",  NO EXISTE EN LA BD, NO SE PUEDE BORRAR. ");
	}
	else
	{
	try{
		 int confirm=JOptionPane.showConfirmDialog
	         (jp, "ESTAS SEGURO DE BORRAR ESTE SUMINISTRO: " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString() , "AVISO BORRADO.", 
		    	JOptionPane.OK_CANCEL_OPTION);	  
	   // si devuelve 0 es OK
	   if (confirm==0)  
	   {  
		
		// actualizo la pieza, sumo unidades y borro la gestion
		Piezas pie = (Piezas)session.get(Piezas.class, comboPiezas.getSelectedItem().toString()); 
		int st = 	pie.getStock();
		int cant = gest.getCantidad();
		st = st + cant;
		pie.setStock(st);
		Transaction tx =session.beginTransaction();
		session.delete(gest);
		session.update(pie);
		tx.commit();
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +", BORRADO DE LA BD. ");
		limpiapantalla(comboPiezas, comboProveedor, comboProyecto, cantidad,
				Importe);
	  } // borrar
		
	}catch (JDBCException j)
	{   vererror.erroresMySQL(j,mensaje); 	
	    session.close();
	    session = sesion.openSession();	}		
	}	
	
	
}//borrarsuministro
private void limpiapantalla(JComboBox comboPiezas, JComboBox comboProveedor,
		JComboBox comboProyecto, JTextField cantidad, JTextField Importe) {
	Importe.setText("");
	cantidad.setText("");
	comboPiezas.setSelectedIndex(0);
	comboProveedor.setSelectedIndex(0);
	comboProyecto.setSelectedIndex(0);
}

///////////////////////////////////////////////////////////////////////
public void modificarsuministro(JComboBox comboPiezas, JComboBox comboProveedor,
		JComboBox comboProyecto, JTextField cantidad, JTextField importe, JLabel mensaje) {
	
	GestionId id = new GestionId(comboProveedor.getSelectedItem().toString(),
			comboPiezas.getSelectedItem().toString(),
			comboProyecto.getSelectedItem().toString() );

	Gestion gest = (Gestion) session.get(Gestion.class, id); 
	if (gest==null){
		// Suministro NO existe 
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +",  NO EXISTE EN LA BD, NO SE PUEDE MODIFICAR. ");
	}
	else
	{
	try{
		// Se modifica
		Proyectos pr = (Proyectos)session.get(Proyectos.class, comboProyecto.getSelectedItem().toString()); 
		Proveedores prov = (Proveedores)session.get(Proveedores.class, comboProveedor.getSelectedItem().toString()); 
		Piezas pie = (Piezas)session.get(Piezas.class, comboPiezas.getSelectedItem().toString()); 
		int canti = Integer.parseInt(cantidad.getText().toString());	
		float impor = canti * pie.getPrecio().floatValue();
		importe.setText(String.valueOf(impor));
		// actualiza pieza, resto cantidad tecleada, sumo la borrada
		int st = pie.getStock();
		st = st - canti;
		int cantiant = gest.getCantidad(); // cantidad anterior
		st = st + cantiant;
		if (st >=10)
		{
		pie.setStock(st);
		gest.setCantidad(canti);
		gest.setId(id);
		gest.setPiezas(pie);
		gest.setProveedores(prov);
		gest.setProyectos(pr);
		
		Transaction tx =session.beginTransaction();
		session.update(gest);
		session.update(pie);
		tx.commit();
		mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
				comboPiezas.getSelectedItem().toString()+ "-" +
				comboProyecto.getSelectedItem().toString()    +", MODIFICADO EN LA BD. ");
		}
		else
		{
			mensaje.setText("SUMINISTRO " +comboProveedor.getSelectedItem().toString() + "-" +
					comboPiezas.getSelectedItem().toString()+ "-" +
					comboProyecto.getSelectedItem().toString()    +", NO SE PUEDE MODIFICAR, "
							+ "EL STOCK ES INFERIOR A 10. ");
		}
	}catch (NumberFormatException e) {
		mensaje.setText("ERROR EN LA CANTIDAD. Debe ser numérico entero." );
	}catch (JDBCException j)
	{   vererror.erroresMySQL(j,mensaje); 	
	    session.close();
	    session = sesion.openSession();	}		
	}	
	
}//modificarsuministro

///////////////////////////////////////////////////////////////////////
public void visualizarsuministros(TextArea textArea) {
	textArea.setText("");
	Query consulta = session.createQuery("from Gestion");
	// codproveedor; codpieza; codproyecto; cantidad
	textArea.append("\n----------------------------------------- DATOS DE GESTION SUMINISTROS-"
			+ "------------------------------------------------------------------------\n\n");

	textArea.append(String.format("%1$-8s", "COD PROV")
			+ String.format("%1$-20s", "  NOMBRE")
			+ String.format("%1$-8s", "COD PIEZ")
			+ String.format("%1$-20s", "  NOMBRE")
			+ String.format("%1$-8s", "COD PROY")
			+ String.format("%1$-40s", "  NOMBRE")
			+ String.format("%1$-10s", "\tCANTIDAD") 
			+ String.format("%1$-11s", "\tPRECIO") 
			+ String.format("%1$-11s", "\tIMPORTE") 
			);

	textArea.append("\n-----------------------------------------------------------------------"
			+ "------------------------------------------------------------------------\n");

    String patron="%-6s %-20s  %-6s  %-20s  %-6s %-40s %8d \t%8.2f \t%9.2f";
    String cadena ="";	
	List q = consulta.list();
	Gestion gest = new Gestion();
	for(int i=0;i<q.size(); i++) {
		gest =  (Gestion) q.get(i);
		BigDecimal pvp = gest.getPiezas().getPrecio();
		float importe =  gest.getCantidad() * pvp.floatValue();
		cadena=String.format(patron,
				            gest.getProveedores().getCodigo(),
				            gest.getProveedores().getNombre(),
				            gest.getPiezas().getCodigo(),
				            gest.getPiezas().getNombre(),
				            gest.getProyectos().getCodigo(),
				            gest.getProyectos().getNombre(),
				            gest.getCantidad(),
				            pvp.floatValue(),
				            importe
				           ); 
			
		textArea.append(cadena + "\n");
	}
	textArea.append("\n-----------------------------------------------------------------------"
			+ "------------------------------------------------------------------------\n");
	
	
}//visualizarsuministros
	
		
///////////////////////////////////////////////////////////////////////

}// fin clase
